unit HostTest;

interface

uses Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs, StdCtrls;

type
  TFrmRsv = class(TForm)
    EditAddr: TEdit;
    EditName: TEdit;
    ButtonByHost: TButton;
    ButtonByName: TButton;
    MemoAddr: TMemo;
    MemoName: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure ButtonByHostClick(Sender: TObject);
    procedure ButtonByAddrClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var FrmRsv: TFrmRsv;

implementation

{$R *.DFM}

uses Winsock;

procedure TFrmRsv.ButtonByHostClick(Sender: TObject);
var WSAData: TWSAData;
    HostEnt: PHostEnt;
    InAddr: PInAddr;
    sName: String;
    pAli, pAddr1, pAddrX: Pointer;
begin
 MemoName.Clear; MemoAddr.Clear;
 sName:=EditName.Text; EditAddr.Text:='?';
 if WSAStartup(MakeWord(1,1),WSAData)=0 then begin
  HostEnt:=GetHostByName(PChar(sName));
  if HostEnt<>nil then begin
   EditName.Text:=HostEnt.h_name;           // offiziellen Hostnamen bernehmen
   pAli:=HostEnt.h_aliases;                 // Zeiger auf Aliaszeigerliste
   while Pointer(pAli^)<>nil do begin       // solange kein Ende der Aliasliste
    MemoName.Lines.Add(PChar(pAli^));       // Alias eintragen
    pAli:=PChar(pAli)+4;                    // Aliaszeiger um 1 erhhen
   end;
   pAddr1:=HostEnt.h_addr_list;             // Zeiger auf Adresszeigerliste
   InAddr:=Pointer(pAddr1^);
   EditAddr.Text:=inet_ntoa(InAddr^);       // offizielle IP-Adresse eintragen
   pAddrX:=PChar(pAddr1)+4;                 // Zeiger auf nchsten Adresszeiger
   while Pointer(pAddrX^)<>nil do begin     // solange kein Ende der Adressliste
    InAddr:=Pointer(pAddrX^);
    MemoAddr.Lines.Add(inet_ntoa(InAddr^)); // weitere Adresse eintragen
    pAddrX:=PChar(pAddrX)+4;
   end;
  end else EditAddr.Text:='???';            // keine DNS-Server-Antwort
 end;
 WSACleanup;
end;

procedure TFrmRsv.ButtonByAddrClick(Sender: TObject);
type TaPInAddr = array[0..255] of PInAddr;  // 255 als willkrliches Maximum (es kostet ja nie Speicherplatz)
     PaPInAddr = ^TaPInAddr;
var WSAData: TWSAData;
    HostEnt: PHostEnt;
    pAdrPtr: PaPInAddr;
    sIP: String;
    nAdr, i: Cardinal;
    pAli : Pointer;
begin
 MemoName.Clear; MemoAddr.Clear;
 sIP:=EditAddr.Text; EditName.Text:='?';
 nAdr:=inet_addr(PChar(sIP));
 if WSAStartup(MakeWord(1,1),WSAData)=0 then begin
  HostEnt:=GetHostByAddr(@nAdr,4,PF_INET);
  if HostEnt<>nil then begin
   EditName.Text:=HostEnt.h_name;           // offiziellen Hostnamen bernehmen
   pAli:=HostEnt.h_aliases;                 // Zeiger auf Aliaszeigerliste
   while Pointer(pAli^)<>nil do begin       // solange kein Ende der Aliasliste
    MemoName.Lines.Add(PChar(pAli^));       // Alias eintragen
    pAli:=PChar(pAli)+4;                    // Aliaszeiger um 1 erhhen
   end;
   pAdrPtr:=Pointer(HostEnt.h_addr_list);   // diesmal ohne Zeigermanipulation !
   EditAddr.Text:=inet_ntoa(pAdrPtr^[0]^);  // offizielle IP-Adresse eintragen
   i:=1;
   while pAdrPtr^[i]<>nil do begin          // nchster Adresszeiger <>0
    MemoAddr.Lines.Add(inet_ntoa(pAdrPtr^[i]^));  // weitere Adresse eintragen
    Inc(i);
   end;
  end else EditAddr.Text:='???';            // keine DNS-Server-Antwort
 end;
 WSACleanup;
end;

end.
